'////////////////////////////////////////////////////////////////////////////////
'//	Variables
'////////////////////////////////////////////////////////////////////////////////
Const	BORDERxoff:Int=32
Const	BORDERyoff:Int=64

Const	BORDERsplash:Float=192

Global	GFXborder01:TImage
Global	GFXborder02:TImage
Global	GFXborder03:TImage
Global	GFXborder04:TImage
Global	GFXborder05:TImage
Global	GFXborder06:TImage
Global	GFXborder07:TImage
Global	GFXborder08:TImage
Global	GFXborder09:TImage

Global	BORDERglow:Float=0
Global	BORDERglowspeed:Float=0

Global	BGmap:TBank=LoadBank("data\misc\BGmap.bnk")
Global	BORDERz1:Float[2,52,35]

Const	GRIDstep:Int=2

Global	gxy:Float[8]
'////////////////////////////////////////////////////////////////////////////////
'//	Setup Grid
'////////////////////////////////////////////////////////////////////////////////

Global grid:gridpoint[,]
grid = New gridpoint[67,51]

For Local a:Float = 0 To 66
	For Local b:Float = 0 To 50
		grid[a,b] = New gridpoint
		grid[a,b].ox = (a*16)
		grid[a,b].oy = (b*16)
		grid[a,b].x = (a*16)
		grid[a,b].y = (b*16)
	Next
Next
'////////////////////////////////////////////////////////////////////////////////
'//	Grid Type
'////////////////////////////////////////////////////////////////////////////////
Type gridpoint

	Field ox#,oy#
	Field x#
	Field y#	
	Field dx#,dy#
'////////////////////////////////////////////////////////////////////////////////
'//	Update Grid
'////////////////////////////////////////////////////////////////////////////////
	Method Update(xx#,yy#)
	
		If Abs(xx-x) > 2 Then dx:+ Sgn(xx-x) 
		If Abs(yy-y) > 2 Then dy:+ Sgn(yy-y) 
					
		If Abs(ox-x) > 1
			x = x + Sgn(ox-x)
			dx:+ Sgn(ox-x)/2 	
		Else
			x = ox
		EndIf
		If Abs(oy-y) > 1
			y = y + Sgn(oy-y)
			dy:+ Sgn(oy-y)/2 
		Else
			y = oy
		EndIf

		dx = dx *.9
		dy = dy *.9

		x = x + dx
		y = y + dy
			
	End Method
'////////////////////////////////////////////////////////////////////////////////
'//	Disrupt Grid
'////////////////////////////////////////////////////////////////////////////////
	Method disrupt(xx#,yy#)
		If Abs(xx) > 8 Then xx = xx/16
		If Abs(yy) > 8 Then yy = yy/16
		dx = dx + xx
		dy = dy + yy
		Local speed# = dx*dx+dy*dy
		If speed > 160 ' 128
			dx = dx/speed*128
			dy = dy/speed*128
		EndIf
	End Method
'////////////////////////////////////////////////////////////////////////////////
'//	Pull Grid
'////////////////////////////////////////////////////////////////////////////////
	Function Pull(x1#,y1#, sz:Int = 4,amnt#=4)
		Local a:Int = x1/16
		Local b:Int = y1/16
		For Local xx:Int = -sz To sz
			For Local yy:Int = -sz To sz
				If a+xx > 0
					If a+xx < 63
						If b+yy > 0
							If b+yy < 47
								If xx*xx + yy*yy < sz*sz							
									Local diffx# = grid[a+xx,b+yy].x-x1
									Local diffy# = grid[a+xx,b+yy].y-y1
									Local dist# = Sqr(diffx*diffx+diffy*diffy)
									If dist > 0
									grid[a+xx,b+yy].dx:- diffx/dist*amnt  '*(1-(dist*dist)/(sz*sz*4*256))
									grid[a+xx,b+yy].dy:- diffy/dist*amnt  '*(1-(dist*dist)/(sz*sz*4*256))
									EndIf
								EndIf
							EndIf
						EndIf
					EndIf
				EndIf
			Next
		Next	
	End Function
'////////////////////////////////////////////////////////////////////////////////
'//	Push Grid
'////////////////////////////////////////////////////////////////////////////////
	Function Push(x1#,y1#, sz:Int = 4,amnt#=1)
		Local a:Int = (x1/16)
		Local b:Int = (y1/16)
		For Local xx:Int = -sz To sz
			For Local yy:Int = -sz To sz
				If a+xx > 0
					If a+xx < 63
						If b+yy > 0
							If b+yy < 47
								Local diffx# = grid[a+xx,b+yy].ox-x1
								Local diffy# = grid[a+xx,b+yy].oy-y1
								Local diffxo# = grid[a+xx,b+yy].ox-grid[a+xx,b+yy].x
								Local diffyo# = grid[a+xx,b+yy].oy-grid[a+xx,b+yy].y								
								Local dist# = diffy*diffy+diffx*diffx
								Local disto# = diffyo*diffyo+diffxo*diffxo
								If dist > 1 And disto < 400
									If dist < 50*50
										grid[a+xx,b+yy].dx:+ diffx*amnt '/dist*amnt
										grid[a+xx,b+yy].dy:+ diffy*amnt '/dist*amnt
									EndIf										
								EndIf
							EndIf
						EndIf
					EndIf
				EndIf
			Next
		Next	
	End Function
'////////////////////////////////////////////////////////////////////////////////
'//	Update Grid
'////////////////////////////////////////////////////////////////////////////////
	Function UpdateGrid()
		For Local a:Int = 1 To 63
			For Local b:Int = 1 To 47
				Local xx# = 0
				xx:+ grid[a-1,b].x
				xx:+ grid[a,b-1].x
				xx:+ grid[a,b+1].x
				xx:+ grid[a+1,b].x
				xx = xx / 4
	
				Local yy# = 0
				yy:+ grid[a-1,b].y
				yy:+ grid[a,b-1].y
				yy:+ grid[a,b+1].y
				yy:+ grid[a+1,b].y
				yy = yy / 4

				grid[a,b].update(xx,yy)
			Next
		Next
	End Function
'////////////////////////////////////////////////////////////////////////////////
'//	Shockwave
'////////////////////////////////////////////////////////////////////////////////
	Function Shockwave(x:Int,y:Int)
		Local a:Int = x/16
		Local b:Int = y/16
		For Local xx:Int = -3 To 3
			For Local yy:Int = -3 To 3
				If xx*xx + yy*yy < 10
					If a+xx > 0
						If a+xx < 63
							If b+yy > 0
								If b+yy < 47
									grid[a+xx,b+yy].disrupt(4*(grid[a+xx,b+yy].x-x),4*(grid[a+xx,b+yy].y-y))								
								EndIf
							EndIf
						EndIf
					EndIf
				EndIf
			Next
		Next	
	End Function
'////////////////////////////////////////////////////////////////////////////////
'//	Draw Grid
'////////////////////////////////////////////////////////////////////////////////
	Function DrawGridLines()
		Local t:Int,a:Int,b:Int
		Local	xoff:Float	
		Local	yoff:Float

		Local	delx:Float
		Local	dely:Float
		Local	colb:Float

		SetBlend(LIGHTBLEND)
		SetScale(1,1)
		SetRotation(0)
		If CONFgrid=2
			SetAlpha(0.4)
			SetLineWidth(2)
		Else
			SetAlpha(0.5)
			SetLineWidth(3)
		End If

		xoff=WINLeft-WINDOWx
		yoff=WINtop-WINDOWy

		If CONFgrid=1
			For a = 0 To 63 Step GRIDstep
				For b = 0 To 47 Step GRIDstep
					gxy[0] = grid[a,b].x
					gxy[1] = grid[a,b].y
				
					gxy[2] = grid[a+GRIDstep,b].x
					gxy[3] = grid[a+GRIDstep,b].y
				
					gxy[4] = grid[a+GRIDstep,b+GRIDstep].x
					gxy[5] = grid[a+GRIDstep,b+GRIDstep].y
				
					gxy[6] = grid[a,b+GRIDstep].x
					gxy[7] = grid[a,b+GRIDstep].y
				
					delX=gxy[4]-gxy[0]-(16*GRIDstep)
					delY=gxy[5]-gxy[1]-(16*GRIDstep)
					If delX<delY Then delX=delY
					If delX<0.0 Then delX=0.0
					If delX>90.0 Then delX=90.0

					colB=Sin(delX)

					SetColor(16+(colb*60),16+(colB*120),192+(colb*64))

					If gxy[1]<>0
						DrawLine(gxy[0]+xoff,gxy[1]+yoff,gxy[2]+xoff,gxy[3]+yoff,False)
					End If
					If gxy[0]<>0
						DrawLine(gxy[0]+xoff,gxy[1]+yoff,gxy[6]+xoff,gxy[7]+yoff,False)
					End If
				Next
			Next
		Else
			If CONFgrid=2
				For a = 0 To 63 
					For b = 0 To 47
						gxy[0] = grid[a,b].x
						gxy[1] = grid[a,b].y
				
						gxy[2] = grid[a+1,b].x
						gxy[3] = grid[a+1,b].y
				
						gxy[4] = grid[a+1,b+GRIDstep].x
						gxy[5] = grid[a+1,b+GRIDstep].y
				
						gxy[6] = grid[a,b+1].x
						gxy[7] = grid[a,b+1].y
				
						delX=gxy[4]-gxy[0]-16
						delY=gxy[5]-gxy[1]-16
						If delX<delY Then delX=delY
						If delX<0.0 Then delX=0.0
						If delX>90.0 Then delX=90.0

						colB=Sin(delX)

						SetColor(16+(colb*60),16+(colB*120),192+(colb*64))

						If gxy[1]<>0
							DrawLine(gxy[0]+xoff,gxy[1]+yoff,gxy[2]+xoff,gxy[3]+yoff,False)
						End If
						If gxy[0]<>0
							DrawLine(gxy[0]+xoff,gxy[1]+yoff,gxy[6]+xoff,gxy[7]+yoff,False)
						End If
					Next
				Next
			End If
		End If

	End Function	
EndType
'////////////////////////////////////////////////////////////////////////////////
'//	Reset Grid
'////////////////////////////////////////////////////////////////////////////////
Function	ResetGrid()
	For Local a:Float = 0 To 66
		For Local b:Float = 0 To 50
			grid[a,b].ox = (a*16)
			grid[a,b].oy = (b*16)
			grid[a,b].x = (a*16)
			grid[a,b].y = (b*16)
			grid[a,b].dx = 0
			grid[a,b].dy = 0
		Next
	Next
End Function
'////////////////////////////////////////////////////////////////////////////////
'//	Draw Border
'////////////////////////////////////////////////////////////////////////////////
Function	DrawBorder()
	Local	x:Int
	Local	y:Int
	Local	z:Byte
	Local	xp:Int
	Local	yp:Int
	Local	c:Float

	For y=0 To 33
		For x=0 To 49
			z=PeekByte(BGmap,(y*50)+x)
			xp=((x*32)-Int(WINDOWx))
			yp=((y*32)-Int(WINDOWy))

			If xp>-48 And xp<GFXw And yp>-80 And yp<GFXh 'And z<>0 And z<>7

				Select	z
					'Case	0
					'	AddImage(GFXborder01,BORDERxoff+xp,BORDERyoff+yp,0,255,255,255,((Sin(BORDERglow)/3)+0.5),0,1,1,lightBLEND)
					Case	1
						AddImage(GFXborder01,BORDERxoff+xp,BORDERyoff+yp,0,255,255,255,((Sin(BORDERglow)/3)+0.5),0,1,1,lightBLEND)
					Case	2
						AddImage(GFXborder02,BORDERxoff+xp,BORDERyoff+yp,0,255,255,255,((Sin(BORDERglow)/3)+0.5),0,1,1,lightBLEND)
					Case	3
						AddImage(GFXborder03,BORDERxoff+xp,BORDERyoff+yp,0,255,255,255,((Sin(BORDERglow)/3)+0.5),0,1,1,lightBLEND)
					Case	4
						AddImage(GFXborder04,BORDERxoff+xp,BORDERyoff+yp,0,255,255,255,((Sin(BORDERglow)/3)+0.5),0,1,1,lightBLEND)
					Case	5
						AddImage(GFXborder05,BORDERxoff+xp,BORDERyoff+yp,0,255,255,255,((Sin(BORDERglow)/3)+0.5),0,1,1,lightBLEND)
					Case	6
						AddImage(GFXborder06,BORDERxoff+xp,BORDERyoff+yp,0,255,255,255,((Sin(BORDERglow)/3)+0.5),0,1,1,lightBLEND)
					'Case	7
					'	c=((BORDERz1[BORDERbuf,x+1,y]+BORDERz1[BORDERbuf,x,y+1]+BORDERz1[BORDERbuf,x+1,y+1]+BORDERz1[BORDERbuf,x,y])/4)
					'	c=(c*16)+32
					'	AddImage(GFXborder07,BORDERxoff+xp,BORDERyoff+yp,0,c,c,128+c,1,0,1,1,lightBLEND)
					Case	8
						AddImage(GFXborder08,BORDERxoff+xp,BORDERyoff+yp,0,255,255,255,((Sin(BORDERglow)/3)+0.5),0,1,1,lightBLEND)
					Case	9
						AddImage(GFXborder09,BORDERxoff+xp,BORDERyoff+yp,0,255,255,255,((Sin(BORDERglow)/3)+0.5),0,1,1,lightBLEND)
				End Select
			End If
		Next
	Next

	BORDERglow=(BORDERglow+8) Mod 360
	If CONFgrid>0
		AddImage(GFXborder07,0,0,0,-1968,-1968,-1968,1,0,1,1,lightBLEND)
	End If

End Function

