'////////////////////////////////////////////////////////////////////////////////
'//	Variables
'////////////////////////////////////////////////////////////////////////////////
Type	tBULLET
	Field	t:Int
	Field	x:Float
	Field	y:Float
	Field	speed:Float
	Field	ang:Float
	Field	rot:Float
	Field	collrad:Float
	Field	damage:Float
	Field	alpha:Float
	Field	scale:Float
	Field	blend:Int
	Field	r:Int
	Field	g:Int
	Field	b:Int
	Field	img:TImage
	Field	xacc:Float
	Field	yacc:Float
End Type
Global BULLETlist:TList=CreateList()

Global	GFXplayerbullet01:TImage
'////////////////////////////////////////////////////////////////////////////////
'//	Do Bullets
'////////////////////////////////////////////////////////////////////////////////
Function	DoBullets()
	Local	i:tBULLET
	Local	kill:Int
	Local	part:tPART
	Local	j:Int
	Local	rad:Float

	For	i:tBULLET = EachIn BULLETlist
		Select i.t
			Case	0
				i.x=(i.x+Sin(i.ang)*i.speed)
				i.y=(i.y+Cos(i.ang)*i.speed)
				i.x:+i.xacc
				i.y:+i.yacc

				kill=0

				If (i.x-i.collrad)<WINleft
					kill=1
				Else
					If (i.x+i.collrad)>WINright
						kill=1
					End If
				End If
	
				If (i.y-i.collrad)<WINtop
					kill=1
				Else
					If (i.y+i.collrad)>WINbot
						kill=1
					End If
				End If

				If CheckBulletKill(i)<>0
					Kill=1
				End If

				AddImage(i.img,i.x-WINDOWx,i.y-WINDOWy,0,i.r,i.g,i.b,i.alpha,i.rot,i.scale,i.scale,i.blend)

				If kill=1
					For j=0 To 1
						part:tPART = New tPART
						part.t=0
						part.accel=8+Rand(1,4)
						part.accelchange=-(part.accel/25)
						part.ang=Rand(0,359)
						part.angchange=0

						rad=Rand(4,8)
						part.x=(i.x+Sin(part.ang)*rad)
						part.y=(i.y+Cos(part.ang)*rad)

						part.rot= (-part.ang)+180
						part.rotchange=0
						part.alpha=1
						part.alphachange=-0.04
						part.xscale=1
						part.yscale=Rnd(1,2)
						part.xscalechange=0
						part.yscalechange=-0.01
						part.img=GFXpart01
						part.blend=LIGHTBLEND
						part.r=255
						part.g=255
						part.b=64
						part.collrad=8
						ListAddLast(particlelist,part)
					Next
					BULLETlist.Remove i
				Else
					gridpoint.push(i.x-GRIDxoff,i.y-GRIDyoff,2,0.02)
				End If
		End Select
	Next

	If PLAYERnextshot>0
		PLAYERnextshot:-1
	End If
End Function
'////////////////////////////////////////////////////////////////////////////////
'//	Do Bullets
'////////////////////////////////////////////////////////////////////////////////
Function	CheckBulletKill:Int(i:tBULLET)
	Local	n:tNME
	Local	p:tPART
	Local	hit:Int
	Local	dis:Float
	Local	xp:Float
	Local	yp:Float
	Local	j:Int
	Local	la:Float

	hit=0

	xp=i.x
	yp=i.y

	For	n:tNME = EachIn nmelist
		If n.mode=1
			dis=Sqr(((xp-n.x)*(xp-n.x))+((yp-n.y)*(yp-n.y)))
			If dis<(i.collrad+n.collrad)
				If n.t=6 And n.counter1=1
					la=ATan2(n.x-i.x,n.y-i.y)
					la=(la-n.ang)

					If Abs(la)>135 And Abs(la)<225
						hit=1
						If n.energy<>999999
							n.energy:-i.damage
							If n.energy<0
								n.mode=2
							End If
							Exit
						Else
							hit=2
						End If
					Else
						hit=3
					End If
				Else
					hit=1
					If n.energy<>999999
						If n.t=7 				'black hole
							n.energy:-(i.damage/2)
							If n.counter1=0
								n.counter1=1

								p:tPART = New tPART
								p.t=1
								p.accel=0.0000001
								p.accelchange=0
								p.ang=0
								p.angchange=0
								p.x=n.x
								p.y=n.y
								p.rot=Rand(0,359)
								p.rotchange=0
								p.alpha=1
								p.alphachange=-0.04
								p.xscale=0
								p.yscale=0
								p.xscalechange=0.25'0.075
								p.yscalechange=0.25'0.075
								p.img=GFXplayerbomb01
								p.blend=LIGHTBLEND
								p.r=n.r
								p.g=n.g
								p.b=n.b
								p.collrad=0
								ListAddLast(particlelist,p)
							End If
							AddExplosion(n.x,n.y)
							AddSFX(cSFXnmekill,n.x)
						Else
							n.energy:-i.damage
						End If
						If n.energy<0
							n.mode=2
						End If
						Exit
					Else
						hit=2
					End If
				End If
			End If
			If n.t=5
				For j=1 To SNAKETAILLENGTH
					If n.tabx[j*SNAKETAILSTEP]<>-1
						dis=Sqr(((xp-n.tabx[j*SNAKETAILSTEP])*(xp-n.tabx[j*SNAKETAILSTEP]))+((yp-n.taby[j*SNAKETAILSTEP])*(yp-n.taby[j*SNAKETAILSTEP])))
						If dis<(i.collrad+8)
							hit=3
						End If
					End If
				Next
			End If
		End If
	Next

	Return(hit)

End Function
