'////////////////////////////////////////////////////////////////////////////////
'//	Variables
'////////////////////////////////////////////////////////////////////////////////
Type	tDRAW
	Field	x:Float
	Field	y:Float
	Field	rot:Float
	Field	alpha:Float
	Field	xscale:Float
	Field	yscale:Float
	Field	blend:Int
	Field	img:Timage
	Field	frame:Int
	Field	r:Int
	Field	g:Int
	Field	b:Int
End Type
Global DRAWlist:TList=CreateList()

'////////////////////////////////////////////////////////////////////////////////
'//	Draw Everything
'////////////////////////////////////////////////////////////////////////////////
Function	RenderAll()
	Local	i:tDRAW

	For	i:tDRAW = EachIn DRAWlist
		If i.r=-1968
			gridpoint.drawgridlines()
		Else
			SetAlpha(i.alpha)
			SetRotation(i.rot)
			SetScale(i.xscale,i.yscale)
			SetBlend(i.blend)
			SetColor(i.r,i.g,i.b)
			DrawImage(i.img,i.x,i.y,i.frame)
		End If
	Next

End Function
'////////////////////////////////////////////////////////////////////////////////
'//	Add Image to Drawlist
'////////////////////////////////////////////////////////////////////////////////
Function	AddImage(img:timage,x:Float,y:Float,frame:Int=0,r:Int=255,g:Int=255,b:Int=255,alpha:Float=1,rot:Float=0,xscale:Float=1,yscale:Float=1,blend:Int=ALPHABLEND)
	Local	i:tDRAW

	i:tDRAW=New(tDRAW)
	i.img=img
	i.x=x
	i.y=y
	i.r=r
	i.g=g
	i.b=b
	i.frame=frame
	i.alpha=alpha
	i.rot=rot
	i.xscale=xscale
	i.yscale=yscale
	i.blend=blend
	ListAddLast(DRAWlist,i)

End Function


