'////////////////////////////////////////////////////////////////////////////////
'//	Variables
'////////////////////////////////////////////////////////////////////////////////
Global	GAMEMODE:Int=0
Global	GAMEpause:Int
Global	GAMEpausedown:Int
Global	GAMEpausedown2:Int
Global	GAMEovermode:Int
Global	GAMEoverdown:Int

Global	HIGHSCORE:Long=16384

Global	SFXingamemusic:TSound
Global	SFXingamemusicCH:TChannel

Global	GAMEmusicon:Int=0

'////////////////////////////////////////////////////////////////////////////////
'//	Do Game
'////////////////////////////////////////////////////////////////////////////////
Function	DoGame()
	Local	k:Int

	Select	GAMEMODE
		Case	0
			SetupGame()
		Case	1
			UpdateGame(1)
		Case	2
			UpdateGameTime()
			UpdateGame()

			If KeyDown(KEY_ESCAPE)
				QUITDOWN=1
				JOYQUITDOWN=1
				GAMEMODE=10
			End If

			'If JOYstarttype=0
			If JOYinputtype[5]=0
				If (JoyGet(5)<-0.2 Or JoyGet(5)>0.2)
					QUITDOWN=1
					JOYQUITDOWN=1
					GAMEMODE=10
				End If
			Else
				If JoyDown(JoyType[5],JOYport[5])
					QUITDOWN=1
					JOYQUITDOWN=1
					GAMEMODE=10
				End If
			End If

		Case	3
			UpdateGame(1)

			PLAYERdeathcount:-1
			If PLAYERdeathcount=0
				If PLAYERlifes>0
					GAMEMODE=4
				Else
					GAMEMODE=5
					GAMEovermode=0
					GAMEoverdown=1
				End If

			End If
		Case	4
			ResetGame()
		Case	5
			GAMEMODE=0
			MODE=0
			TITLEMODE=60

			If PLAYERscore<>0
				HIGHSCOREtablelastscorepos=(FindHighscore(PLAYERscore)+1)
			Else
				HIGHSCOREtablelastscorepos=-1
			End If
		Case	10
			SetupPause()
		Case	11
			DoPause()
	End Select

End Function
'////////////////////////////////////////////////////////////////////////////////
'//	Setup Game
'////////////////////////////////////////////////////////////////////////////////
Function	SetupGame()
	Local	i:Int

	ClearList(MULTIPLYlist)
	ClearList(NMElist)
	ClearList(BULLETlist)
	ClearList(PARTICLElist)
	ClearList(STARlist)
	ClearSFX()
	SetupStars()
	ResetGrid()

	SetupPlayer()
	UpdateWindow()

	GAMEMODE=1
	GAMEpause=0
	GAMEpausedown=0

	GAMEtimeframes=0
	GAMEtimesecs=0
	GAMEtimemins=0
	GAMEtimehours=0

	debugTOTALKILLED=0
	debugTOTALKILLEDNODEATH=0

	ATTACKmode=0
	ATTACKmin=0
	ATTACKmax=0
	ATTACKwavetime=GAMEtimeframes
	ATTACKwavetimedelta=ATTACKwavetime+(ReqFPS*5)
	ATTACKold[0]=0
	ATTACKold[1]=0
	ATTACKold[2]=0
	ATTACKold[3]=0

	ATTACKskill=1

	HIGHSCORE=HIGHSCOREtablescores[0]

	For i=0 To 10
		KILLtype[i]=0
	Next

	For i=0 To 15
		GAMEaward[i]=0
	Next

	If MUSICtype=0
		If GAMEmusicon=0
			SFXingamemusicCH=PlaySound(SFXingamemusic)
			SetChannelVolume(SFXingamemusicCH,MUSICvolume)
			GAMEmusicon=1
		End If
	End If

End Function
'////////////////////////////////////////////////////////////////////////////////
'//	Reset Game
'////////////////////////////////////////////////////////////////////////////////
Function	ResetGame()
	Local	i:Int

	ClearList(MULTIPLYlist)
	ClearList(NMElist)
	ClearList(BULLETlist)
	ClearList(PARTICLElist)
	ClearList(SCORESPRlist)
	ClearSFX()

	ResetGrid()

	ResetPlayer()
	UpdateWindow()

	GAMEMODE=1
	GAMEpause=0
	GAMEpausedown=0

	debugTOTALKILLEDNODEATH=0

	ATTACKmode=0

End Function
'////////////////////////////////////////////////////////////////////////////////
'//	Update Game
'////////////////////////////////////////////////////////////////////////////////
Function	UpdateGame(special:Int=0)
	ClearList(DRAWlist)

	ClearSFX()

	DoPlayer()
	If special<>1
		DoAttackWaves()
		DoNme()
	End If
	DrawStars()
	DrawBorder()
	DoParticles()
	DoBullets()
	DoBomb()
	DoHitScore()
	DoMultiply()
	DrawScore()
	DrawGameTime()

	If CONFgrid>0
		gridpoint.updategrid()
	End If

End Function
'////////////////////////////////////////////////////////////////////////////////
'//	Setup Pause
'////////////////////////////////////////////////////////////////////////////////
Function	SetupPause()
	Local	i:tMENU

	i:tMENU = New tMENU
	i.t=1
	i.y=(GFXh*0.5)
	i.entries=2
	i.text[0]="Press ESCAPE again to QUIT or any"
	i.text[1]="other key to return to the game."
	i.value[0]=0
	i.value[1]=0
	i.selected=-1
	i.bard=2
	i.joyd=1
	i.joyfd=1
	ListAddLast(MENUlist,i)
	GAMEMODE=11

	DoMenus()

	If MUSICtype=0
		If GAMEmusicon=1
			PauseChannel(SFXingamemusicCH)
		End If
	End If

End Function
'////////////////////////////////////////////////////////////////////////////////
'//	Do Pause
'////////////////////////////////////////////////////////////////////////////////
Function	DoPause()
	If KeyDown(KEY_ESCAPE)
		If QUITDOWN=0
			QUITDOWN=1
			GAMEMODE=0
			TITLEMODE=0
			MODE=0
			ClearList(MENUlist)
			If MUSICtype=0
				If GAMEmusicon=1
					StopChannel(SFXingamemusicCH)
					GAMEmusicon=0
				End If
			End If
		End If
	Else
		If AnyKey()=1
			GAMEMODE=2
			ClearList(MENUlist)
			Repeat
			Until AnyKey()=0
			If MUSICtype=0
				ResumeChannel(SFXingamemusicCH)
			End If
		Else
			QUITDOWN=0
		End If
	End If

	'If JOYstarttype=0
	If JOYinputtype[5]=0
		If (JoyGet(5)<-0.2 Or JoyGet(5)>0.2)
			If JOYQUITDOWN=0
				GAMEMODE=0
				TITLEMODE=0
				MODE=0
				ClearList(MENUlist)
				If MUSICtype=0
					If GAMEmusicon=1
						StopChannel(SFXingamemusicCH)
						GAMEmusicon=0
					End If
				End If
			End If
		Else
			If AnyJoy()=1
				GAMEMODE=2
				ClearList(MENUlist)
				Repeat
				Until AnyJoy()=0
				If MUSICtype=0
					ResumeChannel(SFXingamemusicCH)
				End If
			Else
				JOYQUITDOWN=0
			End If
		End If
	Else
		If JoyDown(JoyType[5],JOYport[5])
			If JOYQUITDOWN=0
				GAMEMODE=0
				TITLEMODE=0
				MODE=0
				ClearList(MENUlist)
				If MUSICtype=0
					If GAMEmusicon=1
						StopChannel(SFXingamemusicCH)
						GAMEmusicon=0
					End If
				End If
			End If
		Else
			If AnyJoy()=1
				GAMEMODE=2
				ClearList(MENUlist)
				Repeat
				Until AnyJoy()=0
				If MUSICtype=0
					ResumeChannel(SFXingamemusicCH)
				End If
			Else
				JOYQUITDOWN=0
			End If
		End If
	End If
End Function

