'////////////////////////////////////////////////////////////////////////////////
'//	Add Spinner
'////////////////////////////////////////////////////////////////////////////////
'counter1=number of rezes / counter2=scale / counter3=free / counter4=free / counter5=free
Function	AddSpawn(xpos:Float,ypos:Float)
	Local	i:tNME
	Local	done:Int
	Local	dis:Float

	i:tNME = New tNME
	i.t=10
	i.mode=0
	i.collrad=8

	done=0
	If xpos=0 And ypos=0
		Repeat
			i.x=Rand(WINleft+i.collrad,WINright-i.collrad)
			i.y=Rand(WINtop+i.collrad,WINbot-i.collrad)
			dis=Sqr(((i.x-PLAYERx)*(i.x-PLAYERx))+((i.y-PLAYERy)*(i.y-PLAYERy)))
			If dis>(PLAYERcollrad*8)
				done=1
			End If
		Until(done=1)
	Else
		i.x=xpos
		i.y=ypos
	End If
	i.ang=ATan2(PLAYERy-i.y,PLAYERx-i.x)-90
	i.speed=0
	i.img=GFXnme04
	i.xscale=1
	i.yscale=1
	i.alpha=1
	i.blend=LIGHTBLEND
	i.rot=Rand(0,359)
	i.r=255
	i.g=24
	i.b=255
	i.energy=50
	i.score=50
	i.counter1=0
	i.counter2=1	
	i.counter3=Rnd(0,359)
	i.counter4=i.x	
	i.counter5=i.y	
	i.iamtheone=0
	i.tabx[0]=0
	ListAddLast(NMElist,i)

	'AddSFX(cSFXnme01spawn,i.x)

End Function
'////////////////////////////////////////////////////////////////////////////////
'//	Do Floater
'////////////////////////////////////////////////////////////////////////////////
Function	DoSpawn(i:tNME)

	Select	i.mode
		Case	0
			RezInSpawn(i)
		Case	1
			DoSpawnSearch(i)
		Case	2
			KillSpawn(i)
	End Select
End Function
'////////////////////////////////////////////////////////////////////////////////
'//	Rez In Floater
'////////////////////////////////////////////////////////////////////////////////
'counter1=free / counter2=free / counter3=free / counter4=free / counter5=free
Function	RezInSpawn(i:tNME)
	i.mode=1
	i.counter2=Rand(0,1)
End Function
'////////////////////////////////////////////////////////////////////////////////
'//	Do Floater Search
'////////////////////////////////////////////////////////////////////////////////
'counter1=free / counter2=spin dir / counter3=Angle of Spin / counter4=X Center of Spin / counter5=Y Center of Spin
Function	DoSpawnSearch(i:tNME)
	Local	ox:Float
	Local	oy:Float
	Local	dis:Float

	If i.speed<(PLAYERMAXACCEL*0.75)
		i.speed:+0.125
	Else
		If i.speed>0
			i.speed:-0.125
		End If
	End If

	dis=Sqr(((i.counter4-PLAYERx)*(i.counter4-PLAYERx))+((i.counter5-PLAYERy)*(i.counter5-PLAYERy)))

	If dis>48
		If i.tabx[0]<48
			i.tabx[0]:+2
		End If
	Else
		If i.tabx[0]>0
			i.tabx[0]:-2
			If i.tabx[0]<0
				i.tabx[0]=0
			End If
		End If
	End If
	
	i.ang=ATan2(PLAYERx-i.counter4,PLAYERy-i.counter5)

	ox=i.counter4
	oy=i.counter5

	i.counter4=ox+Sin(i.ang)*i.speed
	i.counter5=oy+Cos(i.ang)*i.speed

	i.x=i.counter4+Sin(i.counter3)*i.tabx[0]
	i.y=i.counter5+Cos(i.counter3)*i.tabx[0]

	If i.x<(WINleft+i.collrad)
		i.x=(WINleft+i.collrad)
	Else
		If i.x>(WINright-i.collrad)
			i.x=(WINright-i.collrad)
		End If
	End If

	If i.y<(WINtop+i.collrad)
		i.y=(WINtop+i.collrad)
	Else
		If i.y>(WINbot-i.collrad)
			i.y=(WINbot-i.collrad)
		End If
	End If

	If i.counter2=0
		i.rot=(i.rot+5)Mod 360
		i.counter3=(i.counter3+4)Mod 360
	Else
		i.rot=(i.rot-5)Mod 360
		i.counter3=(i.counter3-4)Mod 360
	End If

	AddImage(i.img,i.x-WINDOWx,i.y-WINDOWy,0,i.r,i.g,i.b,i.alpha,i.rot,i.xscale,i.yscale,i.blend)

End Function
'////////////////////////////////////////////////////////////////////////////////
'//	Kill Floater
'////////////////////////////////////////////////////////////////////////////////
Function	KillSpawn(i:tNME)
	Local	part:tPART

	AddExplosion(i.x,i.y)

	part:tPART = New tPART
	part.accel=0.0000001
	part.accelchange=0
	part.ang=0
	part.angchange=0
	part.x=i.x
	part.y=i.y
	part.rot=i.rot
	part.rotchange=0
	part.alpha=1
	part.xscale=i.xscale
	part.yscale=i.yscale
	part.img=GFXnme04
	part.blend=LIGHTBLEND
	part.r=i.r
	part.g=i.g
	part.b=i.b
	part.collrad=0
	If i.iamtheone=0
		part.t=1
		part.alphachange=-0.05
		part.xscalechange=0.075
		part.yscalechange=0.075
	Else
		part.t=2
		part.alphachange=0
		part.xscalechange=0
		part.yscalechange=0
		part.rcolchange=1
		part.gcolchange=8
		part.bcolchange=1
	End If
	ListAddLast(particlelist,part)

	UpdateScore(i.score,i.x,i.y)

	nmelist.Remove i
	If i.score<>0
		debugTOTALKILLED:+1
		debugTOTALKILLEDNODEATH:+1
		AddSFX(cSFXnmekill,i.x)
		KILLtype[i.t]:+1
	End If
	'BORDERz1[BORDERbuf,i.x/32,i.y/32]=BORDERsplash/2
	gridpoint.shockwave(i.x-GRIDxoff,i.y-GRIDyoff)
End Function



